---
title: XMLHttpRequest.onreadystatechange
slug: Web/API/XMLHttpRequest/onreadystatechange
tags:
  - API
  - Event
  - Handler
  - Property
  - Reference
  - XHR
  - XMLHttpRequest
---
<div>{{APIRef}}</div>

<p>An {{domxref("EventHandler")}} that is called whenever the <code>readyState</code> attribute changes. The callback is called from the user interface thread. The <strong><code>XMLHttpRequest.onreadystatechange</code></strong> property contains the event handler to be called when the {{domxref("Document/readystatechange_event", "readystatechange")}} event is fired, that is every time the {{domxref("XMLHttpRequest.readyState", "readyState")}} property of the {{domxref("XMLHttpRequest")}} changes.</p>

<div class="warning">
<p><strong>Warning:</strong> This should not be used with synchronous requests and must not be used from native code.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>XMLHttpRequest</em>.onreadystatechange = <em>callback</em>;</pre>

<h3 id="Values">Values</h3>

<ul>
 <li><code><em>callback</em></code> is the function to be executed when the <code>readyState</code> changes.</li>
</ul>

<h2 id="Example">Examples</h2>

<pre class="brush: js">const xhr = new XMLHttpRequest(),
    method = "GET",
    url = "https://developer.mozilla.org/";

xhr.open(<em>method</em>, <em>url</em>, true);
xhr.onreadystatechange = function () {
  // In local files, status is 0 upon success in Mozilla Firefox
  if(xhr.readyState === XMLHttpRequest.DONE) {
    var status = xhr.status;
    if (status === 0 || (status &gt;= 200 &amp;&amp; status &lt; 400)) {
      // The request has been completed successfully
      console.log(xhr.responseText);
    } else {
      // Oh no! There has been an error with the request!
    }
  }
};
xhr.send();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#handler-xhr-onreadystatechange')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.onreadystatechange")}}</p>
